//+------------------------------------------------------------------+
//|                                              Multi-Lot_Trade.mq4 |
//|                                    Copyright  2009, D. Hamilton |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, D. Hamilton"

extern string Symbol1="EURUSD";
extern double Lots1=0.01,Targ_Buy=0,Targ_Sell=0;
extern string Set_Buy="1",Set_Sell="0";
extern int TakeProfit=36,StopLoss=30,Slip1=3;

int Buy_1,Buy_2,Buy_3,Sell_1,Sell_2,Sell_3;
int Gate1B=0,Gate2B=0,Gate3B=0,Gate1S=0,Gate2S=0,Gate3S=0;

//+------------------------------------------------------------------+
//| expert initialization function |
//+------------------------------------------------------------------+
int init()
  {
//----
//---- Set Buy and Sell Targets
   if(Targ_Buy==0){ Targ_Buy=Ask; } if(Targ_Sell==0){ Targ_Sell=Bid; }
//---- Buy_Only and Sell_Only Input Options
   string SB=Set_Buy; if(SB=="Y"||SB=="y"||SB=="Yes"||SB=="yes"||SB=="1"){ Set_Buy="y"; }
   string SS=Set_Sell; if(SS=="Y"||SS=="y"||SS=="Yes"||SS=="yes"||SS=="1"){ Set_Sell="y"; }
   if(Set_Buy!="y"){ Set_Buy="n"; } if(Set_Sell!="y"){ Set_Sell="n"; }
   if(Set_Buy=="Y"&&Set_Sell=="y"){ Set_Sell="n"; }
   if(Set_Buy=="n"&&Set_Sell=="n"){ Set_Buy="y"; }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function |
//+------------------------------------------------------------------+
int start()
  {
   double _pipMultiplier = MathPow(10,MathMod(Digits,2));
//---- Open Buy Orders
   if(Ask==Targ_Buy&&Set_Buy=="y")
     {
      if(Gate1B==0)
        {
         Buy_1=OrderSend(Symbol1,OP_BUY,Lots1,Ask,Slip1,Ask-Point*_pipMultiplier*StopLoss*0.33,Ask+Point*_pipMultiplier*TakeProfit*0.33,"",0,0,Blue);
         Gate1B=1;
        }
      if(Gate2B==0)
        {
         Buy_2=OrderSend(Symbol1,OP_BUY,Lots1,Ask,Slip1,Ask-Point*_pipMultiplier*StopLoss*0.66,Ask+Point*_pipMultiplier*TakeProfit*0.66,"",0,0,Blue);
         Gate2B=1;
        }
      if(Gate3B==0)
        {
         Buy_3=OrderSend(Symbol1,OP_BUY,Lots1,Ask,Slip1,Ask-Point*_pipMultiplier*StopLoss*1.00,Ask+Point*_pipMultiplier*TakeProfit*1.00,"",0,0,Blue);
         Gate3B=1;
        }
     }
//---- Open Sell Orders
   if(Bid==Targ_Sell&&Set_Sell=="y")
     {
      if(Gate1S==0)
        {
         Sell_1=OrderSend(Symbol1,OP_SELL,Lots1,Bid,Slip1,Bid+Point*_pipMultiplier*StopLoss*0.33,Bid-Point*_pipMultiplier*TakeProfit*0.33,"",0,0,Red);
         Gate1S=1;
        } 
      if(Gate2S==0)
        {
         Sell_2=OrderSend(Symbol1,OP_SELL,Lots1,Bid,Slip1,Bid+Point*_pipMultiplier*StopLoss*0.66,Bid-Point*_pipMultiplier*TakeProfit*0.66,"",0,0,Red);
         Gate2S=1;
        } 
      if(Gate3S==0)
        {
         Sell_3=OrderSend(Symbol1,OP_SELL,Lots1,Bid,Slip1,Bid+Point*_pipMultiplier*StopLoss*1.00,Bid-Point*_pipMultiplier*TakeProfit*1.00,"",0,0,Red);
         Gate3S=1;
        } 
     }
//---- Check for Open Buy and Sell Orders
      if(OrderSelect(Buy_1,SELECT_BY_TICKET,MODE_HISTORY)==true)
        {
         datetime ctmTB1=OrderCloseTime(); if(ctmTB1>0){ Gate1B=0; }
        }
      if(OrderSelect(Buy_2,SELECT_BY_TICKET,MODE_HISTORY)==true)
        {
         datetime ctmTB2=OrderCloseTime(); if(ctmTB2>0){ Gate2B=0; }
        }
      if(OrderSelect(Buy_3,SELECT_BY_TICKET,MODE_HISTORY)==true)
        {
         datetime ctmTB3=OrderCloseTime(); if(ctmTB3>0){ Gate3B=0; }
        }
      if(OrderSelect(Sell_1,SELECT_BY_TICKET,MODE_HISTORY)==true)
        {
         datetime ctmTS1=OrderCloseTime(); if(ctmTS1>0){ Gate1S=0; }
        }
      if(OrderSelect(Sell_2,SELECT_BY_TICKET,MODE_HISTORY)==true)
        {
         datetime ctmTS2=OrderCloseTime(); if(ctmTS2>0){ Gate2S=0; }
        }
      if(OrderSelect(Sell_3,SELECT_BY_TICKET,MODE_HISTORY)==true)
        {
         datetime ctmTS3=OrderCloseTime(); if(ctmTS3>0){ Gate3S=0; }
        }
//----
   return(0);
  }
//+------------------------------------------------------------------+